package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: TransactionType
// UnionValue: Remote

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("RemoteTransaction")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class RemoteTransaction implements TransactionBody {
	public final TransactionType type = TransactionType.REMOTE;
	private byte[] hash;

    //
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getHash() {
	    return hash;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setHash(final byte[] value) {
	    this.hash = value;
	}

	public RemoteTransaction hash(final byte[] value) {
	    setHash(value);
	    return this;
	}
	public RemoteTransaction hash(final String value) {
		try {
			setHash(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.hash == null || this.hash.length == 0)) {
            marshaller.writeHash(2, this.hash);
        }
        return marshaller.array();
    }
}
